package main

import (
	"encoding/json"
	"fmt"
	"io/ioutil"
	"log"
	"os"
	"os/exec"
	"path/filepath"
	"strings"
	"time"
)

func main() {
	start := time.Now().UTC()
	out, err := exec.Command("java", "-jar", "tika-app-2.1.0.jar", "-i", "./files", "-o", "./results", "-J").Output()
	if err != nil {
		log.Fatal(err)
	}
	fmt.Print(string(out))

	files := make([]string, 0)
	err = filepath.Walk("./results", func(path string, info os.FileInfo, err error) error {
		if strings.Contains(path, ".json") {
			files = append(files, path)
		}
		return nil
	})
	if err != nil {
		panic(err)
	}

	contentTypes := make([]string, 0)
	for _, file := range files {
		jsonFile, err := os.Open(file)
		if err != nil {
			log.Fatal(err)
		}
		defer jsonFile.Close()
		byteValue, err := ioutil.ReadAll(jsonFile)
		if err != nil {
			log.Fatal(err)
		}
		var data AutoGenerated
		err = json.Unmarshal(byteValue, &data)
		if err != nil {
			log.Fatal(fmt.Sprintf("file %s", file), err)
		}
		if len(data) > 0 {
			contentTypes = append(contentTypes, data[0].ContentType)
		}
	}

	err = os.RemoveAll("./results")
	if err != nil {
		log.Fatal(err)
	}
	err = os.Mkdir("results", 0777)
	if err != nil {
		log.Fatal(err)
	}
	fmt.Println(len(contentTypes), len(files))
	fmt.Println(strings.Join(contentTypes, " -- "))
	fmt.Println(time.Since(start))
}

type AutoGenerated []struct {
	LoC                     string `json:"LoC"`
	XTIKAContentHandler     string `json:"X-TIKA:content_handler"`
	TikaBatchFsRelativePath string `json:"tika_batch_fs:relative_path"`
	ResourceName            string `json:"resourceName"`
	TikaFileExt             string `json:"tika:file_ext"`
	ContentEncoding         string `json:"Content-Encoding"`
	XTIKAParseTimeMillis    string `json:"X-TIKA:parse_time_millis"`
	XTIKAEmbeddedDepth      string `json:"X-TIKA:embedded_depth"`
	XTIKAContent            string `json:"X-TIKA:content"`
	ContentLength           string `json:"Content-Length"`
	XTIKADigestMD5          string `json:"X-TIKA:digest:MD5"`
	ContentType             string `json:"Content-Type"`
}
